### Method

# EDataServer SoupSession handle_authentication_failure

since: 3.46

#### Declaration [src]

    void
    e_soup_session_handle_authentication_failure (
      ESoupSession* session,
      const ENamedParameters* credentials,
      const GError* op_error,
      ESourceAuthenticationResult* out_auth_result,
      gchar** out_certificate_pem,
      GTlsCertificateFlags* out_certificate_errors,
      GError** error
    )

#### Description [src]

Handles authentication failure and sets appropriate value to the `out_auth_result` for the provided `op_error` and used `credentials`. Converts the `op_error` into an appropriate error returned in the `error`.

Also updates connection status on the associated `ESource` with the `session`.

Available since: 3.46

#### Parameters

`credentials`

  Type: `ENamedParameters`

  Credentials used for the authentication.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`op_error`

  Type: `GError`

  A `GError` of the authentication operation.

  The data is owned by the caller of the method.

`out_auth_result`

  Type: `ESourceAuthenticationResult`

  An `ESourceAuthenticationResult` with an authentication result.

  The argument will be set by the function.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.

`out_certificate_pem`

  Type: `gchar**`

  Return location for a server TLS/SSL certificate in PEM format, when the last operation failed with a TLS/SSL error, or `NULL`.

  The argument will be set by the function.
  The argument can be `NULL`.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.
  The value is a NUL terminated UTF-8 string.

`out_certificate_errors`

  Type: `GTlsCertificateFlags`

  Return location for a `GTlsCertificateFlags`, with certificate error flags when the operation failed with a TLS/SSL error, or `NULL`.

  The argument will be set by the function.
  The argument can be `NULL`.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.